/********************************************************************
 *                                                                  *
 * THIS FILE IS PART OF THE OggSQUISH SOFTWARE CODEC SOURCE CODE.   *
 * USE, DISTRIBUTION AND REPRODUCTION OF THIS SOURCE IS RESTRICTED  *
 * BY DISTRIBUTION TERMS THAT SHOULD BE INCLUDED WITH THIS SOURCE.  *
 * PLEASE READ THESE TERMS BEFORE USING OR DISTRIBUTING.            *
 *                                                                  *
 * THE OggSQUISH SOURCE CODE IS (C) COPYRIGHT 1994-1996             *
 * XIPHOPHORUS                                                      *
 *                                                                  *
 ********************************************************************

  file: Cold.c
  function: Toplevel structure encodings for 0.98.6 compatability
            Not used for Ogg only releases
  author: Monty <xiphmont@mit.edu>
  modifications by: Monty
  last modification date: Aug 07 1996

 ********************************************************************/

static long lookup[]={0,1,2,2,2,2,3,3,3,3,3,3,4,4,4,4,
		      4,4,4,4,4,4,4,4,5,5,5,5,5,5,5,5,
		      5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,
		      6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,

		      6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,
		      6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,
		      7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,
		      7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,

		      7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,
		      7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,
		      7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,
		      7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,
		      8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,
		      8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,
		      8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,
		      8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8};

/* Our maxvals gotta be small (8bits or less) */
/* Depth first version of Covta; we don't need a large vector
   cache like we would for breadth first */

/*static void __ogga_Covta(module *m){
  Cxvt *c=(Cxvt *)(m->state);
  void *buf=__ogg_readfromP(c->pipe);
  long insize=__ogg_sizeMB(buf),sofar=0;
  int chan=__ogg_chanMB(buf),ch;

  int reallayers=ilog(insize);
  unsigned long *adaptS=
    (unsigned long *)__ogg_malloc(sizeof(unsigned long)*reallayers,OM_TEMP);
  int *recallS=(int *)__ogg_malloc(sizeof(int)*reallayers,OM_TEMP);
  long *hackS=(long *)__ogg_malloc(sizeof(long)*reallayers,OM_TEMP);

  while(insize>0){
    long size=closest_power_of_2(insize);
    insize-=size;
    sofar+=size;
    reallayers=ilog(size);

    for(ch=0;ch<chan;ch++){
      long *ptr=__ogg_ptrMB(buf,ch)+sofar,i;
      double *work=__ogg_malloc(sizeof(double)*size*2,OM_TEMP);
      unsigned long downshift=0,temp;
      double acc,power;

      for(i=0;i<size;i++)work[i]=labs(ptr[i]);
      
      {
	long j,base;

	i=size;
	base=0;
	while(i>1){
	  j=0;
	  while(j<i){
	    power=(work[base+i+(j>>1)]=work[base+j]+work[base+j+1]);
	    j+=2;
	  }
	  base+=i;
	  i>>=1;
	}
      }
    
      __ogg_Bset(c->bpipe);
    
      acc=power;
      while(acc>0x7fffffffL){
	downshift++;
	acc/=2;
      }

      __ogg_Bout(ilog(acc)+downshift,6);
      if(ilog(acc)+downshift){
	__ogg_Bout(acc,ilog(power));
	__ogg_Bmax=0;
      
	{ /* write */
	  int current=reallayers-1,trunc,i;
	  unsigned long ihi,ilo,index=0,values;
	  unsigned long adapt=AUL,adleft,adright; 
	  for(i=0;i<reallayers;i++)hackS[i]=(size<<1)-(1<<(reallayers-i));

	  recallS[current]=-1;
	  while(1){
	    ihi=(hackS[current]++);
	    ilo=hackS[current-1];

	    trunc=(current<c->layers?current:c->layers)-1;

	    temp=(c->bits[trunc]*adapt)>>(AULSHIFT-reallayers+current+1);
	    if((__ogg_Bbits=lookup[(temp>255)?255:temp])){
	      
	      values=(1<<__ogg_Bbits)-1;
	      __ogg_Bstate=c->backendstate[trunc];
	      temp=rint(work[ilo]/work[ihi]*values);
	      (*(c->write[trunc]))(temp);
	    
	      adleft=temp*adapt/values;
	      adright=adapt-adleft;

	    }else
	      adleft=(adright=0);
	  
	    if(current>1){
	    
	      /* left tree branch */
	      /* store data */

      	      adapt=adleft;
	      adaptS[current]=adright;

	      recallS[current-1]=current;
	      current--;
	    
	    }else{
	      
	      /* right branch */
	      
	      hackS[current-1]+=2;
	      index+=2;
	      if(index>=size)break;

	      /* retrieve data */
	      current=recallS[current];
	      adapt=adaptS[current];
	      current--;
	      recallS[current]=recallS[current+1];

	    }
	  }
	}
      }
      __ogg_free(work);
    }
  }
  __ogg_free(adaptS);
  __ogg_free(recallS);
  __ogg_appendtoP(c->pipe,buf);
}*/

/* Depth first version of Civta; we don't need a large vector
   cache like we would for breadth first */

static void __ogga_Civta(module *m){
  Cxvt *c=(Cxvt *)(m->state);
  int size=__ogg_fixedARG(m,3);
  int chan=__ogg_fixedARG(m,4),ch;
  void *buf=__ogg_allocMB(chan,size);

  __ogg_resetP(c->pipe);
  if(size<1)return;
  size=closest_power_of_2(size);

  { /* read */

    unsigned long reallayers=ilog(size),temp;
    /* Let's see... we need to stack righthand power, adapt */
    unsigned long *adaptS=
      (unsigned long *)__ogg_malloc(sizeof(unsigned long)*reallayers,OM_TEMP);
    int *recallS=(int *)__ogg_malloc(sizeof(int)*reallayers,OM_TEMP);
    
    __ogg_Bset(c->bpipe);
    __ogg_Bmax=0;

    for(ch=0;ch<chan;ch++){
      long *ptr=__ogg_ptrMB(buf,ch);
      int bits=__ogg_Bread(6);
      double passpower;
      
      if(bits){
	if(bits>31){
	  passpower=__ogg_Bread(31);
	  passpower*=1<<(bits-31);
	}else{
	  passpower=__ogg_Bread(bits);
	}
	
	if(size==1)
	  ptr[0]=passpower;
	else{
	  if(bits+ilog(c->maxbits)<32){
	    /* Don't worry about integer overflow */
	    unsigned long *powerS=
	      (unsigned long *)__ogg_malloc(sizeof(unsigned long)*reallayers,
					    OM_TEMP);
	    unsigned long current=reallayers-1,trunc;
	    unsigned long index=0,left,right,values,power=passpower;
	    unsigned long adapt=AUL,adleft,adright;
	    void **backendstate=c->backendstate;
	    long (**readptrs)()=c->read;
	    long *bits=c->bits;
	    
	    recallS[current]=-1;
	    while(1){
	      
	      trunc=(current<c->layers?current:c->layers)-1;
	      
	      temp=(bits[trunc]*adapt)>>(AULSHIFT-reallayers+current+1);
	      if((__ogg_Bbits=lookup[(temp>255)?255:temp])){
		/* OK, we do have a value to read */
		
		values=(1<<__ogg_Bbits)-1;
		__ogg_Bstate=backendstate[trunc];
		temp=(*(readptrs[trunc]))();
		
		left=temp*power/values;
		right=power-left;
		
		adleft=temp*adapt/values;
		adright=adapt-adleft;
		
	      }else{
		left=(right=0);
		adleft=(adright=0);
	      }
	      
	      if(current>1){
		
		/* left tree branch */
		/* store data */
		
		power=left;
		powerS[current]=right;
		adapt=adleft;
		adaptS[current]=adright;
		
		recallS[current-1]=current;
		current--;
		
	      }else{
		
		/* Two leaves, then right branch */
		
		ptr[index++]=left;
		ptr[index++]=right;
		if(index>=size)break;
		
		current=recallS[current];
		/* retrieve data */
		power=powerS[current];
		adapt=adaptS[current];
		
		current--;
		recallS[current]=recallS[current+1];
		
	      }      
	    }
	    
	    __ogg_free(powerS);
	  }else{
	    /* Gotta do it in floats */

	    float *powerS=
	      (float *)__ogg_malloc(sizeof(float)*reallayers,OM_TEMP);
	    unsigned long current=reallayers-1,trunc;
	    unsigned long index=0,values;
	    float left,right,power=passpower;
	    unsigned long adapt=AUL,adleft,adright;
	    void **backendstate=c->backendstate;
	    long (**readptrs)()=c->read;
	    long *bits=c->bits;
	    
	    recallS[current]=-1;
	    while(1){
	      
	      trunc=(current<c->layers?current:c->layers)-1;
	      
	      temp=(bits[trunc]*adapt)>>(AULSHIFT-reallayers+current+1);
	      if((__ogg_Bbits=lookup[(temp>255)?255:temp])){
		/* OK, we do have a value to read */
		
		values=(1<<__ogg_Bbits)-1;
		__ogg_Bstate=backendstate[trunc];
		temp=(*(readptrs[trunc]))();
		
		left=temp*power/values;
		right=power-left;
		
		adleft=temp*adapt/values;
		adright=adapt-adleft;
		
	      }else{
		left=(right=0);
		adleft=(adright=0);
	      }
	      
	      if(current>1){
		
		/* left tree branch */
		/* store data */
		
		power=rint(left);
		powerS[current]=rint(right);
		adapt=adleft;
		adaptS[current]=adright;
		
		recallS[current-1]=current;
		current--;
		
	      }else{
		
		/* Two leaves, then right branch */
		
		ptr[index++]=left;
		ptr[index++]=right;
		if(index>=size)break;
		
		current=recallS[current];
		/* retrieve data */
		power=powerS[current];
		adapt=adaptS[current];
		
		current--;
		recallS[current]=recallS[current+1];
		
	      }      
	    }
	    
	    __ogg_free(powerS);

	  }
	}
      }
    }
    
    __ogg_free(recallS);
    __ogg_free(adaptS);
  }
  
  __ogg_appendtoP(c->pipe,buf);
}

/*static void __ogga_Covt(module *m){
  Cxvt *c=(Cxvt *)(m->state);
  void *buf=__ogg_readfromP(c->pipe);
  int size=__ogg_sizeMB(buf);
  int chan=__ogg_chanMB(buf),ch;

  if(!buf)return;
  size=closest_power_of_2(size);
  if(size<1)return;

  {
    int reallayers=ilog(size);
    int *adaptS=
      (int *)__ogg_malloc(sizeof(int)*reallayers,OM_TEMP);
    int *recallS=(int *)__ogg_malloc(sizeof(int)*reallayers,OM_TEMP);
    long *hackS=(long *)__ogg_malloc(sizeof(long)*reallayers,OM_TEMP);

    for(ch=0;ch<chan;ch++){
      long *ptr=__ogg_ptrMB(buf,ch),i;
      double *work=__ogg_malloc(sizeof(double)*size*2,OM_TEMP);
      unsigned long downshift=0,temp;
      double acc,power;

      for(i=0;i<size;i++)work[i]=labs(ptr[i]);
      
      {
	long j,base;

	i=size;
	base=0;
	while(i>1){
	  j=0;
	  while(j<i){
	    power=(work[base+i+(j>>1)]=work[base+j]+work[base+j+1]);
	    j+=2;
	  }
	  base+=i;
	  i>>=1;
	}
      }
    
      __ogg_Bset(c->bpipe);
    
      acc=power;
      while(acc>0x7fffffffL){
	downshift++;
	acc/=2;
      }

      __ogg_Bout(ilog(acc)+downshift,6);
      if(ilog(acc)+downshift){
	__ogg_Bout(acc,ilog(power));
	__ogg_Bmax=0;
      
	{ /* write */
	  int current=reallayers-1,trunc,i;
	  unsigned long ihi,ilo,index=0,values;
	  int adapt=1,adleft,adright; 
	  for(i=0;i<reallayers;i++)hackS[i]=(size<<1)-(1<<(reallayers-i));

	  recallS[current]=-1;
	  while(1){
	    ihi=(hackS[current]++);
	    ilo=hackS[current-1];

	    trunc=(current<c->layers?current:c->layers)-1;

	    temp=c->bits[trunc];
	    if(adapt){
	      
	      __ogg_Bbits=lookup[(temp>255)?255:temp];	
	      values=(1<<__ogg_Bbits)-1;
	      __ogg_Bstate=c->backendstate[trunc];
	      temp=rint(work[ilo]/work[ihi]*values);
	      (*(c->write[trunc]))(temp);
	      
	      adleft=1;
	      adright=1;
	      if(temp==0)adleft=0;
	      if(temp==values)adright=0;
	      
	    }else
	      adleft=(adright=0);
	  
	    if(current>1){
	    
	      /* left tree branch */
	      /* store data */

      	      adapt=adleft;
	      adaptS[current]=adright;

	      recallS[current-1]=current;
	      current--;
	    
	    }else{
	      
	      /* right branch */
	      
	      hackS[current-1]+=2;
	      index+=2;
	      if(index>=size)break;

	      /* retrieve data */
	      current=recallS[current];
	      adapt=adaptS[current];
	      current--;
	      recallS[current]=recallS[current+1];

	    }
	  }
	}
      }
      __ogg_free(work);
    }
    __ogg_free(adaptS);
    __ogg_free(recallS);
  }
  __ogg_appendtoP(c->pipe,buf);
}*/

static void __ogga_Civt(module *m){
  Cxvt *c=(Cxvt *)(m->state);
  int size=__ogg_fixedARG(m,3);
  int chan=__ogg_fixedARG(m,4),ch;
  void *buf=__ogg_allocMB(chan,size);

  __ogg_resetP(c->pipe);
  if(size<1)return;
  size=closest_power_of_2(size);

  { /* read */

    unsigned long reallayers=ilog(size),temp;
    /* Let's see... we need to stack righthand power, adapt */
    int *adaptS=
      (int *)__ogg_malloc(sizeof(int)*reallayers,OM_TEMP);
    int *recallS=(int *)__ogg_malloc(sizeof(int)*reallayers,OM_TEMP);
    
    __ogg_Bset(c->bpipe);
    __ogg_Bmax=0;

    for(ch=0;ch<chan;ch++){
      long *ptr=__ogg_ptrMB(buf,ch);
      int bits=__ogg_Bread(6);
      double passpower;
      
      if(bits){
	if(bits>31){
	  passpower=__ogg_Bread(31);
	  passpower*=1<<(bits-31);
	}else{
	  passpower=__ogg_Bread(bits);
	}
	
	if(size==1)
	  ptr[0]=passpower;
	else{
	  if(bits+ilog(c->maxbits)<32){
	    /* Don't worry about integer overflow */
	    unsigned long *powerS=
	      (unsigned long *)__ogg_malloc(sizeof(unsigned long)*reallayers,
					    OM_TEMP);
	    unsigned long current=reallayers-1,trunc;
	    unsigned long index=0,left,right,values,power=passpower;
	    int adapt=1,adleft,adright;
	    void **backendstate=c->backendstate;
	    long (**readptrs)()=c->read;
	    long *bits=c->bits;
	    
	    recallS[current]=-1;
	    while(1){
	      
	      trunc=(current<c->layers?current:c->layers)-1;
	      
	      temp=(bits[trunc]);
	      if(adapt){
		/* OK, we do have a value to read */
		__ogg_Bbits=lookup[(temp>255)?255:temp];
		values=(1<<__ogg_Bbits)-1;
		__ogg_Bstate=backendstate[trunc];
		temp=(*(readptrs[trunc]))();
		
		left=temp*power/values;
		right=power-left;
		
		adleft=(temp?1:0);
		adright=(temp==values?0:1);
		
	      }else{
		left=(right=0);
		adleft=(adright=0);
	      }
	      
	      if(current>1){
		
		/* left tree branch */
		/* store data */
		
		power=left;
		powerS[current]=right;
		adapt=adleft;
		adaptS[current]=adright;
		
		recallS[current-1]=current;
		current--;
		
	      }else{
		
		/* Two leaves, then right branch */
		
		ptr[index++]=left;
		ptr[index++]=right;
		if(index>=size)break;
		
		current=recallS[current];
		/* retrieve data */
		power=powerS[current];
		adapt=adaptS[current];
		
		current--;
		recallS[current]=recallS[current+1];
		
	      }      
	    }
	    
	    __ogg_free(powerS);
	  }else{
	    /* Gotta do it in floats */

	    float *powerS=
	      (float *)__ogg_malloc(sizeof(float)*reallayers,OM_TEMP);
	    unsigned long current=reallayers-1,trunc;
	    unsigned long index=0,values;
	    float left,right,power=passpower;
	    int adapt=1,adleft,adright;
	    void **backendstate=c->backendstate;
	    long (**readptrs)()=c->read;
	    long *bits=c->bits;
	    
	    recallS[current]=-1;
	    while(1){
	      
	      trunc=(current<c->layers?current:c->layers)-1;
	      
	      temp=(bits[trunc]);
	      if(adapt){
		/* OK, we do have a value to read */
		__ogg_Bbits=lookup[(temp>255)?255:temp];
		values=(1<<__ogg_Bbits)-1;
		__ogg_Bstate=backendstate[trunc];
		temp=(*(readptrs[trunc]))();
		
		left=temp*power/values;
		right=power-left;
		
		adleft=(temp?1:0);
		adright=(temp==values?0:1);
		
	      }else{
		left=(right=0);
		adleft=(adright=0);
	      }
	      
	      if(current>1){
		
		/* left tree branch */
		/* store data */
		
		power=rint(left);
		powerS[current]=rint(right);
		adapt=adleft;
		adaptS[current]=adright;
		
		recallS[current-1]=current;
		current--;
		
	      }else{
		
		/* Two leaves, then right branch */
		
		ptr[index++]=left;
		ptr[index++]=right;
		if(index>=size)break;
		
		current=recallS[current];
		/* retrieve data */
		power=powerS[current];
		adapt=adaptS[current];
		
		current--;
		recallS[current]=recallS[current+1];
		
	      }      
	    }
	    
	    __ogg_free(powerS);

	  }
	}
      }
    }
    
    __ogg_free(recallS);
    __ogg_free(adaptS);
  }
  
  __ogg_appendtoP(c->pipe,buf);
}

/* Civta  outP inB layersA sizeA chanA # backends # maxvals */

void __oggc_Civta(module *m){

  m->state=fill_vt_struct(m,1);
  m->action=__ogga_Civta;
}

void __oggc_Civt(module *m){

  m->state=fill_vt_struct(m,1);
  m->action=__ogga_Civt;
}
