/********************************************************************
 *                                                                  *
 * THIS FILE IS PART OF THE OggSQUISH SOFTWARE CODEC SOURCE CODE.   *
 * USE, DISTRIBUTION AND REPRODUCTION OF THIS SOURCE IS RESTRICTED  *
 * BY DISTRIBUTION TERMS THAT SHOULD BE INCLUDED WITH THIS SOURCE.  *
 * PLEASE READ THESE TERMS BEFORE USING OR DISTRIBUTING.            *
 *                                                                  *
 * THE OggSQUISH SOURCE CODE IS (C) COPYRIGHT 1994-1996             *
 * XIPHOPHORUS                                                      *
 *                                                                  *
 ********************************************************************

  file: ilog.h
  function: Support routines
  author: Monty <xiphmont@mit.edu>
  modifications by: Monty
  last modification date: Jun 27 1996

 ********************************************************************/

static int ilog(long in){
#ifdef __i386__ /* GCC specific right now */
  /* Simon Greenaway finally kicked me in the butt to add this :) */
  if(!in)return(0);
  __asm__("bsrl %1,%0"
	   :"=r" (in)
	   :"r" (in));
  return(in+1);
#else
  if(in<1024L)/* 10 */
    if(in<32L)/* 5 */
      if(in<8L)/* 3 */
	if(in<2L)/* 1 */
	  if(in<1L)
	    return(0);
	  else
	    return(1);
	else
	  if(in<4L)
	    return(2);
	  else
	    return(3);
      else
	if(in<16L)
	  return(4);
	else
	  return(5);
    else
      if(in<128L)
	if(in<64L)
	  return(6);
	else
	  return(7);
      else
	if(in<512L)
	  if(in<256L)
	    return(8);
	  else
	    return(9);
	else
	  return(10);
  else
    if(in<16384L)
      if(in<4096L)
	if(in<2048L)
	  return(11);
	else
	  return(12);
      else
	if(in<8192L)
	  return(13);
	else
	  return(14);
    else
      if(in<262144L)
	if(in<65536L)
	  if(in<32768L)
	    return(15);
	  else
	    return(16);
	else
	  if(in<131072L)
	    return(17);
	  else
	    return(18);
      else
	if(in<16777216L)
	  if(in<1048576L)
	    if(in<524288L)
	      return(19);
	    else
	      return(20);
	  else
	    if(in<4194304L)
	      if(in<2097152L)
		return(21);
	      else
		return(22);
	    else
	      if(in<8388608L)
		return(23);
	      else
		return(24);
	else
	  if(in<268435456L)
	    if(in<67108864L)
	      if(in<33554432L)
		return(25);
	      else
		return(26);
	    else
	      if(in<134217728L)
		return(27);
	      else
		return(28);
	  else
	    if(in<1073741824L)
	      if(in<536870912L)
		return(29);
	      else
		return(30);
	    else
	      if(in<2147483648UL)
		return(31);
	      else
		return(32);
#endif
}

static int strict_power_of_2(long in){
  int ret=ilog(in);
  if((1<<(ret-1))==in)
    return(ret-1);
  else
    return(-1);
}

