/********************************************************************
 *                                                                  *
 * THIS FILE IS PART OF THE OggSQUISH SOFTWARE CODEC DISTRIBUTION.  *
 * USE, DISTRIBUTION AND REPRODUCTION OF THIS FILE IS RESTRICTED    *
 * BY DISTRIBUTION TERMS THAT SHOULD BE INCLUDED WITH THIS PACKAGE. *
 * PLEASE READ THESE TERMS BEFORE USING OR DISTRIBUTING.            *
 *                                                                  *
 * THE OggSQUISH SOURCE CODE IS (C) COPYRIGHT 1994-1996             *
 * XIPHOPHORUS                                                      *
 *                                                                  *
 ********************************************************************

  file: libogg.h
  function: Include file for using libogg in applications
  author: Monty <xiphmont@mit.edu>
  modifications by: Monty
  last modification date: Jul 31 1996

 ********************************************************************/

#define MAJOR 0
#define MINOR 98
#define REVISION 7

#define ogg_dsp_in     0
#define ogg_dsp_out    1
#define ogg_bit_in     2
#define ogg_bit_out    3
#define ogg_vid_in     4
#define ogg_vid_out    5
#define ogg_txt_in     6
#define ogg_txt_out    7
#define ogg_primary    0
#define ogg_secondary1 1
#define ogg_secondary2 2
#define ogg_secondary3 3
#define ogg_secondary4 4
#define ogg_secondary5 5
#define ogg_secondary6 6
#define ogg_secondary7 7
#define ogg_secondary8 8
#define ogg_secondary9 9

#define OGG_LITTLEENDIAN 0
#define OGG_BIGENDIAN 1
#define OGG_SAMEENDIAN -1
#define OGG_SWAPENDIAN 2


struct ogg_settings{
  int ogg_memory;
  int ogg_precision;
};

struct ogg_dspinfo{
  long rate;
  long channels;
  long dynrange;
};

struct ogg_bitinfo{
  long seekable;
};

#ifdef __cplusplus
extern "C"
{
#endif

extern int   ogg_errno;       
extern char *ogg_strerr;

extern int   ogg_bitstream_major;
extern int   ogg_bitstream_minor;
extern int   ogg_bitstream_revision;
extern char *ogg_bitstream_vendor;

extern int   ogg_script_ready;
extern int   ogg_run_ready;
extern int   ogg_run_loaded;

extern int   ogg_script_err_line;    
extern int   ogg_script_err_statement;
extern int   ogg_script_err_argument; 
extern int   ogg_script_err_number;   
extern char *ogg_script_err_string;

extern char *ogg_comment;

extern void  ogg_script_reset(void);
extern void  ogg_script_parse(char *script);
extern void  ogg_script_use(int scriptnum);
extern void  ogg_script_makeheader(char **ret,long *bytes);
extern long  ogg_script_loadheader(char *header,long bytes);

extern void ogg_settings_get(struct ogg_settings *s);
extern void ogg_settings_submit(struct ogg_settings *s);

extern int ogg_buffer_used(int group,int name);
extern void ogg_buffer_dsp(int group,int name,struct ogg_dspinfo *s);
extern void ogg_buffer_bit(int group,int name,struct ogg_bitinfo *s);
extern long ogg_input_query(int group,int name);

extern void ogg_input_reset(int group,int name);
extern void ogg_input_dsp(int group,int name,void *data,long elements,
			  int width,int endian, int sign, int scale);
extern void ogg_output_dsp(int group,int name, void **data, long *elements, 
			   int width,int endian, int sign, int scale);
extern void ogg_input_bit(int group,int name, char *data, long elements);
extern void ogg_output_bit(int group,int name, char **data, long *elements);

extern void ogg_run_set(int num);
extern void ogg_run(void);
extern void ogg_run_reset(void);
extern void ogg_run_clear(void);

#ifdef __cplusplus
};
#endif
