/********************************************************************
 *                                                                  *
 * THIS FILE IS PART OF THE OggSQUISH SOFTWARE CODEC SOURCE CODE.   *
 * USE, DISTRIBUTION AND REPRODUCTION OF THIS SOURCE IS RESTRICTED  *
 * BY DISTRIBUTION TERMS THAT SHOULD BE INCLUDED WITH THIS SOURCE.  *
 * PLEASE READ THESE TERMS BEFORE USING OR DISTRIBUTING.            *
 *                                                                  *
 * THE OggSQUISH SOURCE CODE IS (C) COPYRIGHT 1994-1996             *
 * XIPHOPHORUS                                                      *
 *                                                                  *
 ********************************************************************

  file: memory.h
  author: Monty <xiphmont@mit.edu>
  modifications by: Monty
  last modification date: May 30 1996

 ********************************************************************/

/* memory management with ripcord wrappers */
extern void *__ogg_malloc(long bytes,long block);
extern void *__ogg_calloc(long el, long size, long block);
extern void __ogg_free(void *ptr);
extern void *__ogg_realloc(void *ptr,long size,long block);
extern void __ogg_ripfree(long block);
extern void __ogg_ripmove(void *ptr,int newblock);
extern int __ogg_ripremove(void *ptr);

/* Mbuffer primitives */
extern void *__ogg_allocMB(int channels,long size);
extern long *__ogg_ptrMB(void *b,int channel);
extern long __ogg_sizeMB(void *b);
extern long __ogg_chanMB(void *b);
extern void __ogg_freeMB(void *in);
extern void *__ogg_ncopyMB(void *d, void *i, int from, int num);
extern void *__ogg_copyMB(void *dest,void *in);
extern void __ogg_setMB(void *i,int val);
extern void __ogg_ripmoveMB(void *b,int group);

/* Ogg_pipe primitives */
extern void __ogg_appendtoP(int pipe,void *b);
extern void __ogg_resetP(int pipenum);
extern void __ogg_sendtoP(int pipe,void *b);
extern void *__ogg_copyfromP(int pipenum);
extern void *__ogg_copynfromP(int pipenum,long n);
extern void *__ogg_readfromP(int pipenum);
extern void __ogg_removenfromP(int pipenum, long n);
extern void *__ogg_readnfromP(int pipenum, long n);
extern long __ogg_testP(int pipenum);
extern void __ogg_registerP(int pipenum);

/* Ogg_variable primitives */
extern void __ogg_writetoV(int num,long val);
extern long __ogg_readfromV(int num);
extern int __ogg_verifyV(int num);
extern void __ogg_registerV(int num);

extern void __ogg_cleanupV(void);
extern void __ogg_cleanupP(void);

