/********************************************************************
 *                                                                  *
 * THIS FILE IS PART OF THE OggSQUISH SOFTWARE CODEC SOURCE CODE.   *
 * USE, DISTRIBUTION AND REPRODUCTION OF THIS SOURCE IS RESTRICTED  *
 * BY DISTRIBUTION TERMS THAT SHOULD BE INCLUDED WITH THIS SOURCE.  *
 * PLEASE READ THESE TERMS BEFORE USING OR DISTRIBUTING.            *
 *                                                                  *
 * THE OggSQUISH SOURCE CODE IS (C) COPYRIGHT 1994-1996             *
 * XIPHOPHORUS                                                      *
 *                                                                  *
 ********************************************************************

  file: strerrs.h
  function: Error strings
  author: Monty <xiphmont@mit.edu>
  modifications by: Monty
  last modification date: Jul 31 1996

 ********************************************************************/

/* Error string defines */

static char *top_errors[]={
  NULL,                             /* 0 */
  "Out of memory",                  /* 1 */
  "Out of data",
  "Virtual memory error",
  "Interrupt",
  "Internal error",                 /* 5 */
  "Incompatible OggSQUISH version", 
  "Not an OggSQUISH bitstream",
  "Bitsream corruption",
  "Script/header not parsed",
  "Script/header not complete",     /* 10 */
  "Script/header already parsed",  
  "Script/header already in use",
  "Invalid settings value",
  "Stream not loss tolerant",
  "I/O buffer not in use",
  "Wrong type of I/O buffer",       /* 16 */
  "Alignment error",                /* 17 */
  "Illegal datum width",            /* 18 */
  "Machine not loaded",             /* 19 */
  "Machine not ready",              /* 20 */
  "Arithmetic error/bitstream failure",               /* 21 */
  NULL};

static char *top100_errors[]={
  "Error while parsing",
  "Error while creating Ogg machine",
  "Runtime error",
  NULL};

static char *parse_errors[]={
  NULL,
  "Missing argument",
  "Duplicate define",
  "Extra symbols after '%'",
  "Syntax error",
  "Type mismatch",
  "Mismatched parentheses",
  "Blank statement",
  "Duplicate label",
  "Unknown module type",
  "Unknown label",
  "Wrong number of arguments",
  "Illegal symbol name",
  "Unknown module",
  NULL};

static char *creation_errors[]={
  "Illegal I/O buffer group/name specified",
  "I/O buffer already in use",
  "Wrong number of variable arguments",
  "Library built without 64 bit support",
  "Cannot embed incompatable module",
  NULL};

